HDU-1045-二分图

Fire Net
Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 10551    Accepted Submission(s): 6216


Problem Description
Suppose that we have a square city with straight streets. A map of a city is a square board with n rows and n columns, each representing a street or a piece of wall. 

A blockhouse is a small castle that has four openings through which to shoot. The four openings are facing North, East, South, and West, respectively. There will be one machine gun shooting through each opening. 

Here we assume that a bullet is so powerful that it can run across any distance and destroy a blockhouse on its way. On the other hand, a wall is so strongly built that can stop the bullets. 

The goal is to place as many blockhouses in a city as possible so that no two can destroy each other. A configuration of blockhouses is legal provided that no two blockhouses are on the same horizontal row or vertical column in a map unless there is at least one wall separating them. In this problem we will consider small square cities (at most 4x4) that contain walls through which bullets cannot run through. 

The following image shows five pictures of the same board. The first picture is the empty board, the second and third pictures show legal configurations, and the fourth and fifth pictures show illegal configurations. For this board, the maximum number of blockhouses in a legal configuration is 5; the second picture shows one way to do it, but there are several other ways. 



Your task is to write a program that, given a description of a map, calculates the maximum number of blockhouses that can be placed in the city in a legal configuration. 


Input
The input file contains one or more map descriptions, followed by a line containing the number 0 that signals the end of the file. Each map description begins with a line containing a positive integer n that is the size of the city; n will be at most 4. The next n lines each describe one row of the map, with a '.' indicating an open space and an uppercase 'X' indicating a wall. There are no spaces in the input file. 


Output
For each test case, output one line containing the maximum number of blockhouses that can be placed in the city in a legal configuration.


Sample Input
4
.X..
....
XX..
....
2
XX
.X
3
.X.
X.X
.X.
3
...
.XX
.XX
4
....
....
....
....
0


Sample Output
5
1
5
2
4

二分图

#include<iostream>
#include<stdio.h>
#include<string.h>
using namespace std;
#define maxn 100
int A[maxn][maxn];
int B[maxn][maxn];
char Map[maxn][maxn];
bool line[maxn][maxn];//有焦点
bool used[maxn];//是否访问过
int girl[maxn];//j和谁匹配过
int p,q;
bool Find(int x)
{
    int i,j;
    for(j=1;j<=q;j++)//扫描每一个纵集合
    {
        if(line[x][j]&&used[j]==false) //在这一次匹配中,j已经访问过了
        {
        used[j]=true;
        if(girl[j]==0||Find(girl[j]))//我认为递归的非叶子都是Find(),叶子节点都是有空位,
         //此句是递归的方向
        {
        girl[j]=x;
        return true;
        }
        }
    }
    return false;
}
void input(int n)
{
    memset(A,0,sizeof(A));
    memset(B,0,sizeof(B));
    memset(line,0,sizeof(line));
    int k=1;
    for(int i=0;i<n;i++)
      scanf("%s",Map[i]);
    for(int i=0;i<n;i++,k++)//行
        for(int j=0;j<n;j++)
         if(Map[i][j]=='X')
         {
            if(j&&j!=n-1&&Map[i][j-1]!='X'&&Map[i][j+1]!='X')k++;
         }
         else A[i][j]=k;
   p=k-1;

   k=1;
   for(int j=0;j<n;j++,k++)
      for(int i=0;i<n;i++)
        if(Map[i][j]=='X')
        {
         if(i&&i!=n-1&&Map[i-1][j]!='X'&&Map[i+1][j]!='X')k++;
        }
       else B[i][j]=k;
    q=k-1;

  for(int i=0;i<n;i++)
    for(int j=0;j<n;j++)
    {
    line[A[i][j]][B[i][j]]=true;
    }

}
void solution(int n)
{
    int all=0;
    for(int i=1;i<=n;i++)
    {
        memset(used,0,sizeof(used));
        if(Find(i)) all++;
    }
    cout<<all<<endl;
}
int main()
{
    int n;
    scanf("%d",&n);
    while(n)
    {
    memset(girl,0,sizeof(girl));
      input(n);
      solution(p);
      scanf("%d",&n);
    }
    return 0;
}
点集=A集合,B集合匹配的结果。而A集合∩B集合=空集,我们需要最多的这样的点,
所以我们需要A和B匹配的越多,限制是A和B只能1:1匹配,如果1:m的话,那么
一个A集合的元素对应m个B集合的元素,那么和B集合有m个不相同的交点,且这些交点都在同一行内,而A集合的元素都是一条长度为X的向量,那么就冲突了。
所以只能11的匹配。
那么只要把A,B看作一个独立集合,求最大匹配即可。

猜你喜欢

转载自blog.csdn.net/kala0/article/details/53148990